package com.yaohun.itemlibrary.data;

import com.yaohun.itemlibrary.main;
import me.Demon.DemonPlugin.DemonAPI;
import org.bukkit.Material;
import org.bukkit.configuration.ConfigurationSection;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.inventory.ItemStack;

import java.io.File;
import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.List;

public class SortData {

    private String sortName;
    private ItemStack showStack;
    private LinkedHashMap<String,ItemStack> stackLinkedMap;
    private File file;
    private FileConfiguration yml;

    public SortData(String sortName, String showStack, ConfigurationSection section, File file,FileConfiguration configuration){
        this.sortName = sortName;
        this.showStack = new ItemStack(Material.valueOf(showStack));
        LinkedHashMap<String,ItemStack> stackList = new LinkedHashMap<>();
        if(section != null) {
            for (String itemKey : section.getKeys(false)) {
                ItemStack stack = section.getItemStack(itemKey).clone();
                stackList.put(itemKey, stack);
            }
        }
        this.stackLinkedMap = stackList;
        this.file = file;
        this.yml = configuration;
        DemonAPI.sendConsoleMessage("§f[§a!§f] §f分类 §8> §6"+sortName+" : "+stackList.size()+" 件");
    }

    public void SaveData(){
        yml.set("showStack",this.showStack.getType().name());
        yml.set("itemStack",null);
        for (String itemKey : stackLinkedMap.keySet()){
            yml.set("itemStack."+itemKey,stackLinkedMap.get(itemKey).clone());
        }
        main.sortManager.saveFile(file,yml);
    }

    public String getSortName() {
        return sortName;
    }

    public ItemStack getShowStack() {
        return showStack;
    }

    public LinkedHashMap<String, ItemStack> getStackLinkedMap() {
        return stackLinkedMap;
    }

    public boolean isStackExit(String itemKey){
        if(this.stackLinkedMap.get(itemKey) == null){
            return false;
        }
        return true;
    }

    public void setStackMap(String itemKey,ItemStack stack){
        stackLinkedMap.put(itemKey,stack);
        SaveData();
    }

    public void deleteStackMap(String itemKey){
        if(stackLinkedMap.get(itemKey) != null) {
            stackLinkedMap.remove(itemKey);
            SaveData();
        }
    }
}
