package com.yaohun.itemlibrary;

import cn.hamster3.cdapi.CDTimeAPI;
import com.yaohun.itemlibrary.data.RandomData;
import com.yaohun.itemlibrary.data.SortData;
import com.yaohun.itemlibrary.gui.SortAllGui;
import com.yaohun.itemlibrary.gui.SortGui;
import com.yaohun.itemlibrary.manage.RandomGroup;
import com.yaohun.itemlibrary.manage.SortManager;
import me.Demon.DemonPlugin.DemonAPI;
import org.bukkit.Bukkit;
import org.bukkit.Material;
import org.bukkit.Sound;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.entity.Player;
import org.bukkit.inventory.ItemStack;
import org.bukkit.plugin.java.JavaPlugin;

public class main extends JavaPlugin {

    public static SortManager sortManager;
    public static RandomGroup randomGroup;
    public static main plugin;
    @Override
    public void onEnable() {
        plugin = this;
        saveDefaultConfig();
        DemonAPI.sendConsoleMessage("§f[§6!§f] §aAuItemStackLibrary (1.0) §f开始加载");
        sortManager = new SortManager();
        randomGroup = new RandomGroup();
        getServer().getPluginManager().registerEvents(new SortGui(),this);
        getServer().getPluginManager().registerEvents(new SortAllGui(),this);
        DemonAPI.sendConsoleMessage("§f[§6!§f] §aAuItemStackLibrary §f加载完成,祝你使用愉快！");
        DemonAPI.sendConsoleMessage("§f[§6!§f] §b极光像素工作室出品");
    }

    @Override
    public void onDisable() {
        sortManager.SaveSortData();
        DemonAPI.sendConsoleMessage("§f[§c!§f] §aAuItemStackLibrary §f卸载完成,欢迎下次使用！");
    }


    @Override
    public boolean onCommand(CommandSender sender, Command cmd, String label, String[] args) {
        if(!sender.isOp()){return true;}
        if (args.length == 0) {
            sender.sendMessage("/ditem sort [分类名] --- 打开分类/创建分类");
            sender.sendMessage("/ditem [分类名] [物品名] --- 保存物品");
            sender.sendMessage("/ditem give [物品名] [数量] <玩家名> --- 给予玩家物品");
            sender.sendMessage("/ditem type [物品id] [数量] <玩家名> --- 给予玩家物品");
            sender.sendMessage("/ditem group [物品组] <玩家名> --- 给予随机物品组");
        }
        if(args.length == 1 && args[0].equalsIgnoreCase("open")){
            SortAllGui.OpenGui((Player) sender);
        }
        if(args.length == 1 && args[0].equalsIgnoreCase("reload")){
            sortManager = new SortManager();
            DemonAPI.sendMessage(sender,"缓存数据和配置文件已重载.");
        }
        if(args.length >= 2){
            if(args[0].equalsIgnoreCase("give")) {
                String name = sender.getName();
                String itemKey = args[1];
                int amount = 1;
                if(args.length >= 3){
                    amount = Integer.parseInt(args[2]);
                }
                if(args.length >= 4){
                    name = args[3];
                }
                if(!sortManager.isStackExit(itemKey)){
                    DemonAPI.sendMessage(sender, "物品 §6"+itemKey+" §a并未找到.");
                    return true;
                }
                ItemStack item = sortManager.getItemStack(itemKey);
                item.setAmount(amount);
                Player player = Bukkit.getPlayer(name);
                if(player == null){
                    DemonAPI.sendMessage(sender, "给予目标玩家 §6"+name+" §a并未找到.");
                    return true;
                }
                player.getInventory().addItem(item);
                DemonAPI.sendMessage(sender, "玩家: §e"+name+" §a物品: §6"+itemKey+" §a数量: §b"+amount);
                return true;
            }
            if(args[0].equalsIgnoreCase("type")) {
                String name = sender.getName();
                String itemId = args[1];
                int amount = 1;
                if(args.length >= 3){
                    amount = Integer.parseInt(args[2]);
                }
                if(args.length >= 4){
                    name = args[3];
                }
                int itemType = 1;
                int itemData = 0;
                if(itemId.contains(":")){
                    String[] strings = itemId.split(":");
                    itemType = Integer.parseInt(strings[0]);
                    itemData = Integer.parseInt(strings[1]);
                }else{
                    itemType = Integer.parseInt(itemId);
                }
                ItemStack item = new ItemStack(itemType,amount,(short) itemData);
                Player player = Bukkit.getPlayer(name);
                if(player == null){
                    DemonAPI.sendMessage(sender, "给予目标玩家 §6"+name+" §a并未找到.");
                    return true;
                }
                player.getInventory().addItem(item);
                DemonAPI.sendMessage(sender, "玩家: §e"+name+" §a物品: §6"+DemonAPI.getItemName(item)+" §a数量: §b"+amount);
                return true;
            }
        }
        if(args.length >= 2){
            if(args[0].equalsIgnoreCase("group")){
                String name = sender.getName();
                String groupName = args[1];
                if(args.length >= 4){
                    name = args[2];
                }
                if(!randomGroup.isRandomDataExit(groupName)){
                    DemonAPI.sendMessage(sender,"随机组 §6"+groupName+" §a不存在.");
                    return true;
                }
                Player player = Bukkit.getPlayer(name);
                if(player == null){
                    DemonAPI.sendMessage(sender, "给予目标玩家 §6"+name+" §a并未找到.");
                    return true;
                }
                RandomData randomData = randomGroup.getRandomData(groupName);
                ItemStack stack = randomData.getRandomStack();
                player.getInventory().addItem(stack);
                DemonAPI.sendMessage(sender, "玩家: §e"+name+" §a随机组: §6"+groupName+" §a物品: §b"+DemonAPI.getItemName(stack));
                return true;
            }
        }
        if(args.length == 2){
            if(args[0].equalsIgnoreCase("sort")) {
                Player player = (Player) sender;
                String sortName = args[1];
                if (sortManager.isSortFileExit(sortName)) {
                    SortGui.OpenGui(player, sortName, 1);
                } else {
                    long createRequest = CDTimeAPI.getCD(player.getUniqueId(), "create_request");
                    if (createRequest < 0) {
                        DemonAPI.sendMessage(sender, "分类不存在§e创建文件§a请再次输入此命令.", Sound.ENTITY_VILLAGER_NO);
                        CDTimeAPI.setPlayerCD(player.getUniqueId(), "create_request", 1000 * 5);
                        return true;
                    }
                    sortManager.createSortFile(sortName);
                    DemonAPI.sendMessage(sender, "分类文件§e" + sortName + "§a创建成功.", Sound.ENTITY_EXPERIENCE_ORB_PICKUP);
                }
            } else {
                String sortName = args[0];
                Player player = (Player) sender;
                ItemStack item = player.getInventory().getItemInMainHand();
                if (DemonAPI.itemIsNull(item) || DemonAPI.itemIsLore(item) || DemonAPI.itemIsName(item)) {
                    DemonAPI.sendMessage(player, "当前手持物品无法保存至物品库.",Sound.ENTITY_VILLAGER_NO);
                    return true;
                }
                if (!sortManager.isSortFileExit(sortName)) {
                    DemonAPI.sendMessage(player, "分类§e"+sortName+"§a并不存在.",Sound.ENTITY_VILLAGER_NO);
                    return true;
                }
                SortData sortData = sortManager.getSortData(sortName);
                String itemKey = args[1];
                if(sortData.isStackExit(itemKey)){
                    sortData.deleteStackMap(itemKey);
                    DemonAPI.sendMessage(player, "删除物品: §c" + itemKey + " §a分类: §6"+sortName, Sound.ENTITY_EXPERIENCE_ORB_PICKUP);
                }else {
                    sortData.setStackMap(itemKey, item);
                    DemonAPI.sendMessage(player, "创建物品: §e" + itemKey + " §a分类: §6"+sortName, Sound.ENTITY_EXPERIENCE_ORB_PICKUP);
                }
            }
        }
        return false;
    }
}
